package com.zhiwei_tech.openapidemo;

import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

import org.json.JSONArray;
import org.json.JSONObject;

import android.content.Context;
import android.content.Intent;
import android.graphics.Color;
import android.os.Handler;
import android.app.Activity;
import android.os.Bundle;
import android.os.Message;
import android.text.TextUtils;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;

import com.zhiwei_tech.openapidemo.RefreshListView.IRefreshListener;

import static com.zhiwei_tech.openapidemo.SaveSharedPreference.*;


public class MainActivity extends Activity implements IRefreshListener {

    //声明需要的全局变量
    public static String uid;
    public static String token;
    public static String testInfo;
    public static List<String> tids = new ArrayList<String>();
    public static List<String> test_name_list = new ArrayList<String>();
    //考试列表的Handler
    final Handler testListHandler = new Handler();
    // 声明控件对象
    private EditText et_name, et_pass;
    //定义一个弹出信息用得Handle
    private final Handler msgHandler = new Handler() {
        public void handleMessage(Message msg) {
            switch (msg.arg1) {
                case R.string.msg_not_network:
                    Toast.makeText(getApplicationContext(),
                            getResources().getString(R.string.msg_not_network),
                            Toast.LENGTH_SHORT).show();
                    break;
                case R.string.msg_wrong_password:
                    Toast.makeText(getApplicationContext(),
                            getResources().getString(R.string.msg_wrong_password),
                            Toast.LENGTH_SHORT).show();
                    break;
                case R.string.msg_unknown_wrong:
                    Toast.makeText(getApplicationContext(),
                            getResources().getString(R.string.msg_unknown_wrong),
                            Toast.LENGTH_SHORT).show();
                    break;
                default:
                    break;
            }
        }
    };

    //元素的缓冲类,用于优化ListView
    private static class ItemViewCache {
        public TextView test_name;

    }

    private class TestListAdapter extends BaseAdapter {
        private Context mContext;

        public TestListAdapter(Context context) {
            this.mContext = context;
        }

        @Override
        public int getCount() {
            return test_name_list.size();
        }

        @Override
        public Object getItem(int position) {
            return null;
        }

        @Override
        public long getItemId(int position) {
            return 0;
        }

        @Override
        public View getView(final int position, View convertView, ViewGroup parent) {
            if (convertView == null) {
                convertView = LayoutInflater.from(mContext).inflate(R.layout.text_list_view, null);
                ItemViewCache viewCache = new ItemViewCache();
                viewCache.test_name = (TextView) convertView.findViewById(R.id.text_test_name);
                convertView.setTag(viewCache);
            }
            ItemViewCache cache = (ItemViewCache) convertView.getTag();
            //设置文本和图片，然后返回这个View，用于ListView的Item的展示
            cache.test_name.setText(test_name_list.get(position));
            cache.test_name.setTextColor(Color.rgb(89, 97, 255));
            cache.test_name.setTag(position);
            cache.test_name.setOnClickListener(new View.OnClickListener() {
                public void onClick(View v) {
                    Intent intent_test_message = new Intent(MainActivity.this,
                            TestMessageActivity.class);
                    intent_test_message.putExtra("uid", uid);
                    intent_test_message.putExtra("token", token);
                    intent_test_message.putExtra("tid", tids.get(position));
                    startActivity(intent_test_message);
                }
            });
            return convertView;
        }
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {

        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_test_list, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_logout) {
            logout();
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getSchoolId(MainActivity.this).length() == 0) {
            // 设置显示的视图
            setContentView(R.layout.activity_main);
            // 通过 findViewById(id)方法获取用户名的控件对象
            et_name = (EditText) findViewById(R.id.edit_name);
            // 通过 findViewById(id)方法获取用户密码的控件对象
            et_pass = (EditText) findViewById(R.id.edit_pass);
            et_name.setText("20120101");
            et_pass.setText("123");
        } else {
            final String school_id = getSchoolId(MainActivity.this);
            final String pass = getPass(MainActivity.this);
            //新建子线程获得考试，不能在主线程进行HTTP请求
            new Thread() {
                public void run() {
                    loginByPost(school_id, pass);
                }
            }.start();
        }
    }

    @Override
    public void onRefresh() {
        new Thread() {
            public void run() {
                getTestList(); // 调用getTest方法
            }
        }.start();
    }

    /**
     * 通过android:onClick="login"指定的方法 ， 要求这个方法中接受你点击控件对象的参数v
     */

    public void logout() {
        try {
            clearAlldata(MainActivity.this);
            setContentView(R.layout.activity_main);
            et_name = (EditText) findViewById(R.id.edit_name);
            et_pass = (EditText) findViewById(R.id.edit_pass);
            et_name.setText("20120101");
            et_pass.setText("123");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void login(View v) {
        // 获取点击控件的id
        int id = v.getId();
        // 根据id进行判断进行怎么样的处理
        switch (id) {
            // 登陆事件的处理
            case R.id.btn_login:
                // 获取用户名
                final String school_id = et_name.getText().toString();
                // 获取用户密码
                final String pass = et_pass.getText().toString();

                if (TextUtils.isEmpty(school_id) || TextUtils.isEmpty(pass)) {
                    Toast.makeText(this, "用户名或者密码不能为空", Toast.LENGTH_LONG).show();
                } else {
                    // 开启子线程
                    new Thread() {
                        public void run() {
                            loginByPost(school_id, pass); // 调用loginByPost方法
                        }
                    }.start();
                }
                break;
        }

    }

    /**
     * POST请求操作
     */
    private void loginByPost(final String school_id, String pass) {
        try {
            // 请求的地址
            String spec = "https://chengjiyun.com/demo/?q=school-users/api/login";
            // 传递的数据
            String data = "id=" + URLEncoder.encode(school_id, "UTF-8")
                    + "&pass=" + URLEncoder.encode(pass, "UTF-8");
            // 返回字符串
            final String userInfo = WeikeUtility.GetDataByPost(spec, data);
            if ((!userInfo.equals("链接失败")) && (!userInfo.equals("{\"msg\":\"wrong password\"}")))
            {
                //转化为json对象
                JSONObject obj = new JSONObject(userInfo);
                token = obj.getString("token");
                uid = obj.getString("uid");
                //缓存
                setVariable(MainActivity.this, PREF_SCHOOL_ID, school_id);
                setVariable(MainActivity.this, PREF_PASS, pass);
                // 开启子线程获得考试内容
                new Thread() {
                    public void run() {
                        getTestListCache();
                        getTestList(); // 调用getTest方法
                    }
                }.start();
            } else {
                if (userInfo.equals("链接失败") || userInfo.equals("")) {
                    new Thread() {
                        public void run() {
                            getTestListCache();
                        }
                    }.start();
                    Message msg = msgHandler.obtainMessage();
                    msg.arg1 = R.string.msg_not_network;
                    msgHandler.sendMessage(msg);
                } else {
                    Message msg = msgHandler.obtainMessage();
                    msg.arg1 = R.string.msg_wrong_password;
                    msgHandler.sendMessage(msg);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //更新界面
    private void updateTestUI() {
        try {
            setContentView(R.layout.activity_test_list);
            final RefreshListView listView_test = (RefreshListView)
                    findViewById(R.id.list_view_test);
            listView_test.setInterface(this);

            TestListAdapter testListAdapter = new TestListAdapter(this);
            listView_test.setAdapter(testListAdapter);
            listView_test.refreshComplete();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    private List updateTestListName() {
        try {
            JSONObject ObjTestInfo = new JSONObject(testInfo);
            JSONArray testList = ObjTestInfo.getJSONArray("exams");
            int len = testList.length();
            test_name_list.clear();
            for (int i = 0; i < len; i++) {
                JSONObject test_name = new JSONObject(testList.getString(i));
                test_name_list.add(test_name.getString("name"));
            }
            return test_name_list;
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    private void updateTids() {
        try {
            JSONObject ObjTestInfo = new JSONObject(testInfo);
            JSONArray testList = ObjTestInfo.getJSONArray("exams");
            int len = testList.length();
            tids.clear();
            for (int i = 0; i < len; i++) {
                JSONObject test_item = new JSONObject(testList.getString(i));
                tids.add(test_item.getString("tid"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //获得考试列表的缓存
    private void getTestListCache() {
        try {
            if (getTestInfo(MainActivity.this).length() != 0) {
                testInfo = getTestInfo(MainActivity.this);
                final Runnable testUpdateCache = new Runnable() {
                    public void run() {
                        updateTestListName();
                        updateTids();
                        updateTestUI();
                    }
                };
                Thread t = new Thread() {
                    public void run() {
                        testListHandler.post(testUpdateCache);
                    }
                };
                t.start();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void getTestList() {
        try {
            // 请求的地址
            String testSpec = "https://chengjiyun.com/demo/?q=transcripts/api/get-student-exams/" +
                    URLEncoder.encode(uid, "UTF-8") + "/" + URLEncoder.encode(token, "UTF-8");
            // 根据地址用方法获取数据
            testInfo = WeikeUtility.GetDataByGet(testSpec);
            if (!testInfo.equals("链接失败") && (!testInfo.equals(""))) {
                //缓存考试列表
                setVariable(MainActivity.this, PREF_TESTINFO, testInfo);
                final Runnable testUpdateResults = new Runnable() {
                    public void run() {
                        updateTestListName();
                        updateTids();
                        updateTestUI();
                    }
                };
                Thread t = new Thread() {
                    public void run() {
                        testListHandler.post(testUpdateResults);
                    }
                };
                t.start();
            } else {
                if (testInfo.equals("链接失败") || testInfo.equals("")) {
                    Message msg = msgHandler.obtainMessage();
                    msg.arg1 = R.string.msg_not_network;
                    msgHandler.sendMessage(msg);
                } else {
                    Message msg = msgHandler.obtainMessage();
                    msg.arg1 = R.string.msg_unknown_wrong;
                    msgHandler.sendMessage(msg);
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}