package com.zhiwei_tech.openapidemo;

import android.app.Activity;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;

import android.view.Menu;
import android.view.MenuItem;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.TableLayout;
import android.widget.TableRow;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONObject;

import java.net.URLEncoder;

import static com.zhiwei_tech.openapidemo.SaveSharedPreference.clearAlldata;


public class TestMessageActivity extends Activity {
    //声明需要的变量
    private String testMessage;
    private String tid;
    //声明控件
    private WebView webView_high_charts;
    //更新考试信息界面
    private Handler testMessageHandler = new Handler();


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_test_list, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_logout) {
            logout();
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_test_message);
        final Bundle extras = getIntent().getExtras();
        tid = extras.getString("tid");
        new Thread() {
            public void run() {
                // 调用getTest方法
                getTestMessage(extras.getString("uid"), extras.getString("token"), tid);
            }
        }.start();

    }

    public void logout() {
        try {
            clearAlldata(TestMessageActivity.this);
            Intent intent_test_message = new Intent(TestMessageActivity.this, MainActivity.class);
            startActivity(intent_test_message);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void updateTestMessageUI() {
        try {
            TableLayout TabL_test_message = (TableLayout)
                    findViewById(R.id.table_layout_test_message);
            JSONObject object_TestMessage = new JSONObject(testMessage);
            JSONObject object_testMessageTable = object_TestMessage.getJSONObject("table");
            JSONArray array_testHeader = object_testMessageTable.getJSONArray("header");
            //header处理
            int length_header = array_testHeader.length();
            TableRow tableRow_list = new TableRow(this);
            tableRow_list.setPadding(0, 20, 0, 0);
            TabL_test_message.addView(tableRow_list);
            for (int i = 0; i < length_header; i++) {
                TextView text_header = new TextView(this);
                text_header.setText(array_testHeader.getString(i));
                text_header.setBackgroundColor(Color.rgb(255, 255, 255));
                text_header.setPadding(2, 10, 2, 0);
                text_header.setTextSize(9);
                text_header.setBackgroundResource(R.drawable.setbar_bg);
                tableRow_list.addView(text_header);
            }
            //rows处理
            JSONArray array_testMark = object_testMessageTable.getJSONArray("rows");
            String score_column_chart = object_TestMessage.getString("score_column_chart");
            String rank_radar_chart = object_TestMessage.getString("rank_radar_chart");
            String total_score_bar_chart = object_TestMessage.getString("total_score_bar_chart");
            int length_rows = array_testMark.length();
            for (int i = 0; i < length_rows; i++) {
                TableRow tableRow_rows = new TableRow(this);
                TabL_test_message.addView(tableRow_rows);
                JSONArray array_row = array_testMark.getJSONArray(i);
                if (!array_row.getString(0).equals("进退步")) {
                    int length_row = array_row.length();
                    for (int r = 0; r < length_row; r++) {
                        TextView text_row = new TextView(this);
                        text_row.setText(array_row.getString(r));
                        text_row.setPadding(4, 10, 4, 0);
                        text_row.setBackgroundResource(R.drawable.setbar_bg);
                        text_row.setTextSize(9);
                        tableRow_rows.addView(text_row);
                    }
                }
            }
            //webView信息处理
            webView_high_charts = (WebView) findViewById(R.id.webView_high_chart);
            //配置webView
            webView_high_charts.getSettings().setJavaScriptEnabled(true);
            String html = "<!doctype html>\n" +
                    "<html lang=\"en\">\n" +
                    "<head>\n" +
                    "<meta name=\"viewport\" content=\"width=device-width,target-densitydpi=" +
                    "high-dpi, user-scalable=no\"/>" +
                    "\t<script type=\"text/javascript\" src=\"file:///android_asset/js/" +
                    "jquery.1.9.1.min.js\"></script>\n" +
                    "\t<script type=\"text/javascript\" src=\"file:///android_asset/js/" +
                    "highcharts.js\"></script>\n" +
                    "\t<script type=\"text/javascript\" src=\"file:///android_asset/js/" +
                    "highcharts-more.js\"></script>\n" +
                    "</head>\n" +
                    "<body>\n" +
                    score_column_chart +
                    "<div id=\"score_column_chart\" style=\"width:100%;height:240px;" +
                    " zoom:0.8\"></div>" +
                    rank_radar_chart +
                    "<div id=\"rank_radar_chart\" style=\"width:100%;height:240px;" +
                    " zoom:0.8\"></div>" +
                    total_score_bar_chart +
                    "<div id=\"total_score_bar_chart\" style=\"width:100%;height:240px;" +
                    " zoom:0.8\"></div>" +
                    "</body>\n" +
                    "</html>";
            webView_high_charts.loadDataWithBaseURL(null, html, "text/html", "utf-8", null);
            //覆盖webView默认通过第三方或者默认浏览器打开网页的行为,使网页可以在webView中打开
            webView_high_charts.setWebViewClient(new WebViewClient() {
                @Override
                public boolean shouldOverrideUrlLoading(WebView view, String url) {
                    //返回值为true时，webView在控件中打开
                    view.loadUrl(url);
                    return true;
                }
                //webViewClient帮助处理一些webView页面请求和控制
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private String getTestMessageCache() {
        testMessage = SaveSharedPreference.getScoreByTid(TestMessageActivity.this, tid);
        return testMessage;
    }

    private void getTestMessage(final String userId, final String token, final String tid) {
        try {
            String testMessageSpec = "https://chengjiyun.com/demo/?q=transcripts/api" +
                    "/get-student-exam-info/" + URLEncoder.encode(userId, "UTF-8") + "/"
                    + URLEncoder.encode(token, "UTF-8") + "/" + URLEncoder.encode(tid, "UTF-8");
            testMessage = WeikeUtility.GetDataByGet(testMessageSpec);
            if (testMessage.equals("链接失败") || (testMessage.equals(""))) {
                testMessage = getTestMessageCache();
            }
            final Runnable testMessageResults = new Runnable() {
                public void run() {
                    updateTestMessageUI();
                }
            };
            if ((!testMessage.equals("链接失败")) && (!testMessage.equals(""))) {
                SaveSharedPreference.setVariable(TestMessageActivity.this, tid, testMessage);
                Thread t = new Thread() {
                    public void run() {
                        testMessageHandler.post(testMessageResults);
                    }
                };
                t.start();
            } else {
                System.out.println("获取考试失败.........");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
